# 5.03.15 - db refactoring

ALTER TABLE `disciplines` CHANGE LectionCount LectureCount int(11) NOT NULL DEFAULT '0';

ALTER TABLE students DROP FOREIGN KEY students_ibfk_1;
ALTER TABLE disciplines_groups DROP FOREIGN KEY disciplines_groups_ibfk_2;

ALTER TABLE students DROP KEY StudyGroupID;
ALTER TABLE disciplines_groups DROP KEY DisciplineID_2;
ALTER TABLE disciplines_groups DROP KEY StudyGroupID;

ALTER TABLE `students` CHANGE StudyGroupID GroupID int(11) NOT NULL;
ALTER TABLE `disciplines_groups` CHANGE StudyGroupID GroupID int(11) NOT NULL;

ALTER TABLE `students` ADD INDEX `GroupID` (`GroupID`);
ALTER TABLE `disciplines_groups` ADD INDEX `GroupID` (`GroupID`);
ALTER TABLE `disciplines_groups` ADD UNIQUE KEY `DisciplineID_2` (`DisciplineID`,`GroupID`);


ALTER TABLE `disciplines_groups`
ADD CONSTRAINT `disciplines_groups_ibfk_2` FOREIGN KEY (`GroupID`) REFERENCES `study_groups` (`ID`);
ALTER TABLE `students`
ADD CONSTRAINT `students_ibfk_1` FOREIGN KEY (`GroupID`) REFERENCES `study_groups` (`ID`);


ALTER TABLE  `page_access`
CHANGE  `Pagename`  `Pagename` VARCHAR(150) CHARACTER SET utf8 NOT NULL ;

ALTER TABLE  `page_access` ADD UNIQUE (`Pagename`);
ALTER TABLE  `accounts` ADD UNIQUE (`ActivationCode`);


ALTER TABLE  `general_settings` ADD  `Name` VARCHAR(50) CHARACTER SET utf8 NOT NULL ;
UPDATE `general_settings` SET general_settings.Name = 'SemesterID' WHERE general_settings.ID = 1;
UPDATE `general_settings` SET general_settings.Name = 'HashKey' WHERE general_settings.ID = 2;
ALTER TABLE  `general_settings` ADD UNIQUE (`Name`);

# just for fun :/
UPDATE `modules`
SET modules.OrderNum = 3141592
WHERE modules.OrderNum = 3141692;




# 15.03.15 - student's groups memorization

CREATE TABLE IF NOT EXISTS `students_groups` (
    `ID` int(11) NOT NULL AUTO_INCREMENT,
    `StudentID` int(11) NOT NULL,
    `GroupID` int(11) NOT NULL,
    `SemesterID` int(11) NOT NULL,
    `IsStudyLeave` tinyint(1) NOT NULL DEFAULT '0',
    `Date` date NULL,
    PRIMARY KEY (`ID`),
    UNIQUE KEY `StudentID_2` (`StudentID`,`GroupID`,`SemesterID`),
    KEY `SemesterID` (`SemesterID`),
    KEY `StudentID` (`StudentID`),
    KEY `GroupID` (`GroupID`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


# constraints
ALTER TABLE `students_groups`
    ADD CONSTRAINT `students_groups_ibfk_1` FOREIGN KEY (`StudentID`) REFERENCES `students` (`ID`),
    ADD CONSTRAINT `students_groups_ibfk_2` FOREIGN KEY (`GroupID`) REFERENCES `study_groups` (`ID`),
    ADD CONSTRAINT `students_groups_ibfk_3` FOREIGN KEY (`SemesterID`) REFERENCES `semesters` (`ID`);

# save groups
INSERT INTO `students_groups` (StudentID, GroupID, SemesterID)
SELECT DISTINCT students.ID, students.GroupID, semesters.ID
    FROM `students`
    CROSS JOIN `semesters`;

# clear useless data
ALTER TABLE  `students` DROP FOREIGN KEY  `students_ibfk_1` ;
ALTER TABLE  `students` DROP INDEX  `GroupID` ;
ALTER TABLE  `students` DROP  `GroupID` ;


# 13.04.15

ALTER TABLE `students_groups` CHANGE IsStudyLeave `IsStudyLeave` tinyint(1) NOT NULL DEFAULT '0' ;


